Bug 1310128 - Review Request: zpaq - Incremental journaling back-up archiver
Review Request: zpaq - Incremental journaling back-up archiver
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jan Pokorný
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2016-02-19 09:26 EST by Petr Pisar
Modified: 2016-04-06 11:42 EDT (History)
2 users (show)

See Also:
Fixed In Version: zpaq-7.05-1.fc25
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-04-06 11:42:20 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jpokorny: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Petr Pisar 2016-02-19 09:26:58 EST
Spec URL: https://ppisar.fedorapeople.org/zpaq/zpaq.spec
SRPM URL: https://ppisar.fedorapeople.org/zpaq/zpaq-7.05-1.fc24.src.rpm
Description:
This is a journaling archiver optimized for user-level incremental backup of
directory trees. It supports AES-256 encryption, 5 multi-threaded compression
levels, and content-aware file fragment level deduplication. For backups it
adds only files whose date has changed, and keeps both old and new versions.
You can roll back the archive date to restore from old versions of the
archive. The default compression level is faster than zip usually with better
compression. zpaq uses a self-describing compressed format to allow for future
improvements without breaking compatibility with older versions of the
program.

Fedora Account System Username: ppisar


A library from this package is bundled in lrzip package now. This package will be used for unbundling the library.
Comment 1 Upstream Release Monitoring 2016-03-03 03:07:34 EST
ppisar's scratch build of zpaq-7.06-1.fc25.src.rpm for f25 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=13210797
Comment 2 Petr Pisar 2016-03-03 03:18:32 EST
(In reply to Upstream Release Monitoring from comment #1)
> ppisar's scratch build of zpaq-7.06-1.fc25.src.rpm for f25 completed
> http://koji.fedoraproject.org/koji/taskinfo?taskID=13210797

That was a release candidate provided by upstream for tests.
Comment 3 Jan Pokorný 2016-03-07 12:42:28 EST
For the moment, just a tiny nit up to your consideration:

rpmlint for zpaq-libs.x86_64:
W: unused-direct-shlib-dependency /usr/lib64/libzpaq.so.0.1 /lib64/libm.so.6

Possible solution per
https://fedoraproject.org/wiki/Common_Rpmlint_issues#unused-direct-shlib-dependency:

--- Makefile.orig	2016-03-07 18:13:32.293963439 +0100
+++ Makefile	2016-03-07 18:14:35.381048568 +0100
@@ -14,7 +14,7 @@
 	$(CXX) -fPIC -DPIC $(CPPFLAGS) $(CXXFLAGS) -o $@ -c libzpaq.cpp
 
 $(SONAME): libzpaq.o
-	$(CXX) $(LDFLAGS) -shared -Wl,-soname,$(SONAME) -o $@ $<
+	$(CXX) $(LDFLAGS) -Wl,--as-needed -shared -Wl,-soname,$(SONAME) -o $@ $<
 
 libzpaq.so: $(SONAME)
 	ln -s $(SONAME) libzpaq.so
Comment 4 Petr Pisar 2016-03-08 11:35:01 EST
rpmlint does not print the warning in my Fedora 25. Interesting.

It's true that the libm is listed as needed, but I as you can see, I do not pass "-lm" to the compiler, so this looks like a bug in GCC. And if I pass -Wl,--as-needed, the dependency on libm will disappear, but ldd will complain about another library:

$ ldd -u  libzpaq.so.0.1 
Unused direct dependencies:
        /lib64/libgcc_s.so.1

I will add the -Wl,--as-needed into LDFLAGS.
Comment 5 Petr Pisar 2016-03-08 11:50:07 EST
There is an old discussion about it <https://gcc.gnu.org/ml/gcc/2005-01/msg00238.html> and the answer was "requiring users to explicitly supply -lm is a bug" because "mathematical functions are part of the standard library".
Comment 6 Petr Pisar 2016-03-08 11:58:17 EST
(In reply to Petr Pisar from comment #4)
> but ldd will complain about another library:
> 
> $ ldd -u  libzpaq.so.0.1 
> Unused direct dependencies:
>         /lib64/libgcc_s.so.1
> 
It was my fault. I typed something wrong. It actually works.
Comment 7 Petr Pisar 2016-03-08 11:59:02 EST
Update package is on these addresses:

Spec URL: https://ppisar.fedorapeople.org/zpaq/zpaq.spec
SRPM URL: https://ppisar.fedorapeople.org/zpaq/zpaq-7.05-1.fc25.src.rpm
Comment 8 Jan Pokorný 2016-03-11 13:38:27 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- All build dependencies are listed in BuildRequires, except for any that
  are listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: coreutils make gcc-c++
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2


===== MUST items =====

C/C++:
[X]: Package does not contain kernel modules.
[X]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[X]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.

comment:
Per http://mattmahoney.net/dc/zpaq204.pdf (p.22):

> I (Matt Mahoney) am not aware of any patents protecting any of the
> techniques needed to fully implement a compression or decompression
> algorithm or product according to this specification. I have not
> filed for patents on any of the techniques described here and will
> not do so.

Casual patent search haven't shown anything that would appear to document
ZPAQ.

[-]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[X]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 5 files have unknown license. Detailed
     output of licensecheck in /home/mock/booth/zpaq/zpaq/licensecheck.txt

comment:
I wonder if the "combined" licenses doesn't effectively make the library
being MIT licensed (you shouldn't touch it unless you agree to MIT).
I know MIT is not copyleft, but when the code is directly combined,
it's not the same as linking...

[-]: License file installed when any subpackage combination is installed.
[X]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[X]: %build honors applicable compiler flags or justifies otherwise.
[X]: Package contains no bundled libraries without FPC exception.

comment:
If https://github.com/y-256/libdivsufsort (not verified whether this is the
authoritative location) ever gets packaged, would be good to reconsider
the in-code ("soft") bundling, at least.

[X]: Changelog in prescribed format.
[X]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[X]: Development files must be in a -devel package
[X]: Package uses nothing in %doc for runtime.
[X]: Package consistently uses macros (instead of hard-coded directory
     names).
[X]: Package is named according to the Package Naming Guidelines.
[X]: Package does not generate any conflict.
[X]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[X]: Requires correct, justified where necessary.
[X]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[X]: Useful -debuginfo package or justification otherwise.
[?]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[X]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[X]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.

comment:
Subjective opinion: in this case of "public domain except this well
defined part (MIT)" provided in free form within the source files,
it's not needed.

[X]: Final provides and requires are sane (see attachments).
[X]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in zpaq-
     libs , zpaq-devel

comment:
The note is bogus in this case, as "zpaq" RPM carries the binary using
the associated library no other subpackage shall require it.
-devel requires -libs in a proper way.

[X]: Package functions as described.

comment:
Per %check.

[X]: Latest version is packaged.

comment:
Even newer version packaged for a test [comment 2] :-)

[X]: Package does not include license text files separate from upstream.
[X]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[X]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[X]: %check is present and all tests pass.
[X]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.

Source checksums
----------------
http://mattmahoney.net/dc/zpaq705.zip :
  CHECKSUM(SHA256) this package     : d8abe3e3620d4c6f3ddc1da149acffa4c24296fd9c74c9d7b62319e308b63334
  CHECKSUM(SHA256) upstream package : d8abe3e3620d4c6f3ddc1da149acffa4c24296fd9c74c9d7b62319e308b63334


===== Additional comments =====

rather important points:

- https://fedoraproject.org/wiki/Packaging:Guidelines#Downstream_.so_name_versioning
  In cases where upstream ships unversioned .so library (so this is not needed
  for plugins, drivers, etc.), the packager MUST try to convince upstream to
  start versioning it. 

minor glitches up to the consideration:

- zpaq.spec: group tag unnecessary
  [https://fedoraproject.org/wiki/packaging:guidelines#tags_and_sections]

- zpaq-7.05-cast-negative-values-in-models-definiton.patch
  + zpaq-7.05-Silent-a-signess-ambiguity-comparison-warning.patch:
  s/signess/signedness/

notes:

- rpmlint:
  zpaq-libs.x86_64: w: undefined-non-weak-symbol
                       /usr/lib64/libzpaq.so.0.1
                       libzpaq::error(char const*)
  -- apparently a symbol to be delived by the library user
Comment 9 Jan Pokorný 2016-03-11 13:47:01 EST
Petře, please:

- disregard "These BR are not needed: coreutils make gcc-c++",
  apparently this has been already changed

- see the in-line comments (in part, to review the review)

- what's important:
  - have you tried convincing upstream to version the library?
  - will libdivsufsort be used as yet another entry in the chained
    unbundling?
  - should not -libs package declare mere MIT license in case
    libdivsufsort part will not be unbundled?
Comment 10 Petr Pisar 2016-03-14 09:28:32 EDT
(In reply to Jan Pokorný from comment #9)
>   - have you tried convincing upstream to version the library?

I sent upstream all the patches. The next version contains two my patches. It does not contain the patch for building as a library. I did not receive any other response from the upstream. Therefore I conclude upstream is not interested in building a shared library.

>   - will libdivsufsort be used as yet another entry in the chained
>     unbundling?
I did not think about unbundling it because it's pasted into middle of a source file. But I can add a "bundled(libdivsufsort)" Provides and then try to unbundle it.

The linked upstream <http://code.google.com/p/libdivsufsort/> does not exist anymore. This metadata mirror <http://www.antepedia.com/detail/p/libdivsufsort.html> lists 2.0.1 as the latest release and the links to source archive still work.

There seems to be <https://github.com/lh3/libdivsufsort> and more recent <https://github.com/y-256/libdivsufsort>. Thank you for the link.

>   - should not -libs package declare mere MIT license in case
>     libdivsufsort part will not be unbundled?

Only the libdivsufsort code is MIT. zpaq and zpaq-devel packages could be marked as "Public Domain" only. After unbundling, zpaq-libs could also be marked so. But I haven't yet verified unbundling is possible.

> I wonder if the "combined" licenses doesn't effectively make the library
> being MIT licensed (you shouldn't touch it unless you agree to MIT).

Whatever "combined" means, listing all involved licenses does not harm. And it's more accurate because on source level, some lines have one license, other lines have other license.

> Subjective opinion: in this case of "public domain except this well
> defined part (MIT)" provided in free form within the source files,
> it's not needed.

This is good point. Except that actually means a binary package must provide the libdivsufsort copyright and license text in addition to the shared library. I will extract it from the source and package it as a %license.
Comment 11 Petr Pisar 2016-03-17 08:49:35 EDT
I added the bundled(libdivsufsort) Provide, the libdivsufsort copying text and I changes the License tag so only zpaq-libs is MIT and Public Domain. I hope that's everything.

Updated package is on these addresses:

Spec URL: https://ppisar.fedorapeople.org/zpaq/zpaq.spec
SRPM URL: https://ppisar.fedorapeople.org/zpaq/zpaq-7.05-1.fc25.src.rpm
Comment 12 Jan Pokorný 2016-04-04 13:31:40 EDT
Sorry for staling this a bit.

All looks good, but still there's one thing that could link zpaq to
libdivsufsort better.  I've found that there's a "lite" version of
libdivsufsort-2.0.0 that directly corresponds to the embedded code:

https://libdivsufsort.googlecode.com/files/libdivsufsort-lite.zip
(via
http://web.archive.org/web/20160122130127/https://code.google.com/p/libdivsufsort/downloads/list
as I cannot access the original address)

Then, the note about the changed types would become spurious,
and the more probable embedding scenario would get documented.

Will approve (I swear!) as soon as this is responded to (strong
resistence against this or evidence from upstream that original
scenario was indeed followed also counts).
Comment 13 Petr Pisar 2016-04-05 11:44:30 EDT
I changed the comment and renamed the extracted license file. You should have become archeologist.

Updated package is on the same addresses.
Comment 14 Jan Pokorný 2016-04-05 12:32:01 EDT
No more comments :)
Comment 15 Gwyn Ciesla 2016-04-06 08:44:51 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/zpaq
Comment 16 Petr Pisar 2016-04-06 11:42:20 EDT
Thank you for the review and the repository.

Note You need to log in before you can comment on or make changes to this bug.